# Speak incoming messages in IRSSI
# (C) Klaus Knopper 2008
# License: GPL Version 2.1
#

# !reverse <text> sends back the text reversed.

use Irssi;
use Socket;
use Encode;
use strict;
use vars qw($VERSION %IRSSI);

$VERSION = "1.00";
%IRSSI = (
    authors     => 'Klaus Knopper',
    name        => 'speak',
    description => 'Speaks messages in IRSSI using speech-dispatcher',
    license     => 'GNU GENERAL PUBLIC LICENSE Version 2.1'
);

sub speak {
my $what = shift;
# print "Saying $what";
print SPD encode("utf-8","$what")."\n";
}

sub event_message {
	# $server = server record where the message came
	# $data = the raw data received from server, with PRIVMSGs it is:
	#         "target :text" where target is either your nick or #channel
	# $nick = the nick who sent the message
	# $host = host of the nick who sent the message
	my ($server, $data, $nick, $host) = @_;

	# split data to target/text
	my ($target, $text) = $data =~ /^(\S*)\s:(.*)/;

	# skip lines not beginning with !reverse

	if (!$server->ischannel($target)) {
		# private message, $target contains our nick, so we'll need
		# to change it to $nick
		$target = $nick;
	}
	# $text = $text =~ s/'//g;
	speak("$nick: $text");
#	Irssi::signal_continue($server, $text, $target, $host);

#	$server->command("notice $target said $text.");
}

# MAIN

#my $server = "localhost";
#my $port = 1314;
#my $server_addr =(gethostbyname($server))[4];
#my $server_struct = pack("S n a4 x8", AF_INET, $port, $server_addr);
#my $proto = (getprotobyname('tcp'))[2];    
#socket(FESTIVAL, PF_INET, SOCK_STREAM, $proto)|| die "Failed to initialize socket: $!\n";
#connect(FESTIVAL, $server_struct) || die "Failed to connect() to server: $!\n";
#select(FESTIVAL); $|=1; select(STDOUT);

open(SPD,"|spd-say -P message -N irssi -m some -e >/dev/null 2>&1") or die; 
select SPD; $|=1; select STDOUT;

Irssi::signal_add('event privmsg', 'event_message');


# Irssi::signal_add('event privmsg', 'event_privmsg');
